<template>
	<section is="flickity" ref="flickity" :options="flickityOptions" class="slider-wrapper">
		<div class="layout-wrapper layout-wrapper--absolute">
			<header class="slider__head" >
				<h1 class="slider__head__el heading heading--main" ref="sliderHeaderHeading">Contest</h1>
				<p class="slider__head__el slider__copy" ref="sliderHeaderParagraph">
					Lorem ipsum dolor sit amet, consectetur adipisicing elit. Aliquam aliquid commodi cum dolore eveniet
					in ipsa laudantium magnam mollitia natus nihil nulla optio quam quas rerum suscipit, tenetur ullam
					voluptates.
					<br> Lorem ipsum dolor sit amet, consectetur adipisicing elit. Aliquam aliquid commodi cum
					dolore eveniet in ipsa laudantium magnam mollitia natus nihil nulla optio quam quas rerum
					suscipit, tenetur ullam voluptates.
				</p>

				<div class="slider__head__el btn-wrapper" ref="sliderHeaderButtons">
					<router-link to="/gallery" class="btn btn--sec">Gallery showcase</router-link>
					<router-link to="/partecipate" class="btn btn--main">Participate</router-link>
				</div>

			</header>
		</div>
		<div class="slider__el">
			<img data-flickity-lazyload="https://unsplash.it/g/1920/800?image=0" alt="" class="slider__media">
		</div>
		<div class="slider__el">
			<img data-flickity-lazyload="https://unsplash.it/g/1920/800?image=1" alt="" class="slider__media">
		</div>
		<div class="slider__el">
			<img data-flickity-lazyload="https://unsplash.it/g/1920/800?image=2" alt="" class="slider__media">
		</div>
		<div class="slider__el">
			<img data-flickity-lazyload="https://unsplash.it/g/1920/800?image=3" alt="" class="slider__media">
		</div>
	</section>
</template>

<script>
import Flickity from "@/components/Flickity";
import { TweenMax } from "greensock";

export default {
  components: {
    Flickity: Flickity
  },
  name: "Slider",
  data: function() {
    return {
      flickityOptions: {
        wrapAround: true,
        pageDots: false,
        cellAlign: "left",
        cellSelector: ".slider__el",
        setGallerySize: false,
        lazyLoad: true
      }
    };
  },
  methods: {
    animateSliderHeader: function() {
      const elements = [
        this.$refs.sliderHeaderHeading,
        this.$refs.sliderHeaderParagraph,
        this.$refs.sliderHeaderButtons
      ];

      TweenMax.staggerTo(
        elements,
        1,
        {
          y: 0,
          scale: 1,
          opacity: 1,
          ease: Power4.easeOut
        },
        0.25
      );
    }
  },
  mounted: function() {
    this.$refs.flickity.on("lazyLoad", (event, cellElement) => {
      cellElement.style.backgroundImage = "url(" + event.target.src + ")";
      cellElement.style.opacity = 1;
    });

    this.animateSliderHeader();
  }
};
</script>

<style scoped lang="scss">
@import "../styles/breakpoints.scss";

.slider-wrapper {
  height: calc(100vh - 78px);
  position: relative;
}

.slider__head {
  max-width: 75%;
  position: absolute;
  left: 10%;
  top: 50%;
  z-index: 2;
  padding-top: 1em;
  padding-bottom: 1em;
  background-color: rgba(255, 255, 255, 0.4);
  transform: translateY(-50%);
}

.slider__head {
  max-width: 50%;
  padding-right: 2em;
  padding-left: 2em;
}

@include media-breakpoint-down(md) {
  .slider__head {
    width: 80%;
    max-width: 100%;
    left: 10%;
  }
}

.slider__head__el {
  opacity: 0;
  transform: matrix(0.5, 0, 0, 0.5, 0, -22);
}

.slider__el {
  width: 100%;
  height: 100%;
  opacity: 0;
  background-size: cover;
  background-position: center center;
  background-repeat: no-repeat;
  transition: opacity 1.5s ease-out;
}

.slider__media {
  visibility: hidden;
}
</style>